Attribute VB_Name = "GblChemFFOA"
' Copyright 2003-2004 by Kazuya Ujihara <ujihara.jp>.
'
' The contents of this file are subject to the Mozilla Public License Version 1.1
' (the "License"); you may not use this file except in compliance with the License.
' You may obtain a copy of the License at http://www.mozilla.org/MPL/
'
' Software distributed under the License is distributed on an "AS IS" basis,
' WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
' for the specific language governing rights and limitations under the License.
'
' The Original Code is 'ChemFormatter'.
'
' The Initial Developer of the Original Code is Kazuya Ujihara. Portions created by
' the Initial Developer are Copyright (C) 2003-2004 by Kazuya Ujihara.
' All Rights Reserved.
'
' Contributor(s): all the names of the contributors are added in the source code
' where applicable.

Option Explicit

'Grouping symbols of ProgID
Public Const PROG_ID_START As String = "!<"
Public Const PROG_ID_END As String = ">"

'Command Bar name
Public Const CBR_NAME As String = "ChemFormatter"

Private AppInstance As Object 'Application

Sub CreateAddInCommandBarButton( _
    ByVal ToolB As FormatApplyers, _
    ByVal MenuB As FormatApplyers, _
    ByVal Application As Object, _
    ByVal ConnectMode As AddInDesignerObjects.ext_ConnectMode, _
    ByVal AddInInst As Object)
    
    On Error GoTo CreateAddInCommandBarButton_Err
    
    Set AppInstance = Application
    
    Dim Added As Boolean
    Dim CommandBar As Office.CommandBar
    Set CommandBar = GetOrAddCommandBar(CBR_NAME, Added)

    On Error Resume Next

    Dim ProgID As String
    ProgID = PROG_ID_START & AddInInst.ProgID & PROG_ID_END
    
    On Error GoTo CreateAddInCommandBarButton_Err

    Dim FormatCommandBar As CommandBar
    Set FormatCommandBar = AppInstance.CommandBars("Format")
    Dim ChemFormatterPU As Office.CommandBarPopup
    Set ChemFormatterPU = FormatCommandBar.FindControl(, , "ChemFormatter")
    If ChemFormatterPU Is Nothing Then
        Set ChemFormatterPU = FormatCommandBar.Controls.Add(msoControlPopup, , "ChemFormatter")
        ChemFormatterPU.Tag = "ChemFormatter" 'I don't know why does it need.
        ChemFormatterPU.Caption = "ChemFormatter"
    End If
    
    On Error GoTo CreateAddInCommandBarButton_Err
    
    If ToolB.Formatter.Supported("ChangeStyleForR") Then
        Set ToolB.ChangeStyleForR = AddCommandButton(CommandBar, "ChangeStyleForR", LoadResString(2001), 10001, ProgID)
        Set MenuB.ChangeStyleForR = AddCommandButton(ChemFormatterPU.CommandBar, "ChangeStyleForR-Menu", LoadResString(2001), 10001, ProgID)
    End If
    
    If ToolB.Formatter.Supported("ApplyStyleForChemFormula") Then
        Set ToolB.ApplyStyleForChemFormula = AddCommandButton(CommandBar, "ChemFormulaStyle", LoadResString(2002), 10002, ProgID)
        Set MenuB.ApplyStyleForChemFormula = AddCommandButton(ChemFormatterPU.CommandBar, "ChemFormulaStyle-Menu", LoadResString(2002), 10002, ProgID)
    End If
    
    If ToolB.Formatter.Supported("ApplyStyleForIon") Then
        Set ToolB.ApplyStyleForIon = AddCommandButton(CommandBar, "ChemIon", LoadResString(2005), 10005, ProgID)
        Set MenuB.ApplyStyleForIon = AddCommandButton(ChemFormatterPU.CommandBar, "ChemIon-Menu", LoadResString(2005), 10005, ProgID)
    End If
    
    If ToolB.Formatter.Supported("ApplyStyleForChemName") Then
        Set ToolB.ApplyStyleForChemName = AddCommandButton(CommandBar, "ChemNameStyle", LoadResString(2003), 10003, ProgID)
        Set MenuB.ApplyStyleForChemName = AddCommandButton(ChemFormatterPU.CommandBar, "ChemNameStyle-Menu", LoadResString(2003), 10003, ProgID)
    End If
    
    If ToolB.Formatter.Supported("ApplyStyleForJournalReference") Then
        Set ToolB.ApplyStyleForJournalReference = AddCommandButton(CommandBar, "JournalRefStyle", LoadResString(2004), 10004, ProgID)
        Set MenuB.ApplyStyleForJournalReference = AddCommandButton(ChemFormatterPU.CommandBar, "JournalRefStyle-Menu", LoadResString(2004), 10004, ProgID)
    End If
    
    If ToolB.Formatter.Supported("ApplyNMRFormat") Then
        Set ToolB.ApplyNMRFormat = AddCommandButton(CommandBar, "NMRFormat", LoadResString(2006), 10006, ProgID)
        Set MenuB.ApplyNMRFormat = AddCommandButton(ChemFormatterPU.CommandBar, "NMRFormat-Menu", LoadResString(2006), 10006, ProgID)
    End If
    
    If ToolB.Formatter.Supported("ShowNMRFormatSetting") Then
        Set MenuB.ShowNMRFormatSetting = AddCommandButton(ChemFormatterPU.CommandBar, "NMRFormatSetting-Menu", LoadResString(2106), 0, ProgID)
    End If
    
    On Error GoTo CreateAddInCommandBarButton_Err
    
    If Added Then CommandBar.Visible = True
        
    Dim ToolsCommandBar As CommandBar
    Set ToolsCommandBar = AppInstance.CommandBars("Tools")
    With ToolsCommandBar
        Dim COMAddInCommandButton As CommandBarButton
        Set COMAddInCommandButton = .FindControl(, 3754) '3754 is ID of COM add-in
        If COMAddInCommandButton Is Nothing Then
            Dim AddInCommandButton As CommandBarButton
            Set AddInCommandButton = .FindControl(, 943) '943 is ID of Add-in
            
            On Error Resume Next
                'Some Office Application such as FrontPage does not have COM Add-in ControlButton
            
            If AddInCommandButton Is Nothing Then
                Set COMAddInCommandButton = .Controls.Add(msoControlButton, 3754)
            Else
                Set COMAddInCommandButton = .Controls.Add(msoControlButton, 3754, AddInCommandButton.Index + 1)
            End If
            
            On Error GoTo CreateAddInCommandBarButton_Err
        
        End If
    End With
    
    Dim HelpCommandBar As CommandBar
    Set HelpCommandBar = AppInstance.CommandBars("Help")
    Set MenuB.ShowAbout = AddCommandButton(HelpCommandBar, "ChemFFOAbout-Menu", "About ChemFormatter for Office", 0, ProgID)
    
CreateAddInCommandBarButton_End:
    Exit Sub

CreateAddInCommandBarButton_Err:
    AddInErr Err
    Resume CreateAddInCommandBarButton_End
End Sub

Private Function AddCommandButton( _
        ByVal CommandBar As Office.CommandBar, _
        ByVal Tag As String, _
        ByVal Caption As String, _
        ByVal PictureResID As Long, _
        ByVal OnAction As String) As Office.CommandBarButton
    Dim CommandBarButton As Office.CommandBarButton
    Set CommandBarButton = CommandBar.FindControl(, , Tag)
    If CommandBarButton Is Nothing Then
        Set CommandBarButton = CommandBar.Controls.Add(msoControlButton, , Tag)
        With CommandBarButton
            .Caption = Caption
            .Tag = Tag
            If PictureResID <> 0 Then
                Dim pic As IPictureDisp
                Set pic = LoadResPicture(PictureResID, vbResBitmap)
                Clipboard.SetData pic, vbCFBitmap
                .PasteFace
                Clipboard.Clear
            End If
            .OnAction = OnAction
        End With
    End If
    Set AddCommandButton = CommandBarButton
End Function

Private Function GetOrAddCommandBar(ByVal Name As String, Optional ByRef Added As Boolean) As Office.CommandBar
    Added = False
    Dim CommandBar As Office.CommandBar
    
    On Error Resume Next
    
    Set CommandBar = AppInstance.CommandBars(Name)
    If Err.Number <> 0 Then
        Set CommandBar = AppInstance.CommandBars.Add(Name)
        Added = True
    End If
    
    On Error GoTo 0
    Set GetOrAddCommandBar = CommandBar
End Function

Function RemoveAddInCommandBarButton(ByVal _
    RemoveMode As AddInDesignerObjects.ext_DisconnectMode)

    On Error GoTo RemoveAddInCommandBarButton_Err
    
    If RemoveMode = ext_dm_UserClosed Then
        On Error Resume Next
        AppInstance.CommandBars(CBR_NAME).Delete
        AppInstance.CommandBars("Format").Controls("ChemFormatter").Delete
        AppInstance.CommandBars("Help").Controls.Item("About ChemFormatter for Office").Delete
        On Error GoTo RemoveAddInCommandBarButton_Err
    End If
    
RemoveAddInCommandBarButton_End:
    Exit Function
    
RemoveAddInCommandBarButton_Err:
    AddInErr Err
    Resume RemoveAddInCommandBarButton_End
End Function
