VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PowerPointChemFomatter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Copyright 2003-2004 by Kazuya Ujihara <ujihara.jp>.
'
' The contents of this file are subject to the Mozilla Public License Version 1.1
' (the "License"); you may not use this file except in compliance with the License.
' You may obtain a copy of the License at http://www.mozilla.org/MPL/
'
' Software distributed under the License is distributed on an "AS IS" basis,
' WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
' for the specific language governing rights and limitations under the License.
'
' The Original Code is 'ChemFormatter'.
'
' The Initial Developer of the Original Code is Kazuya Ujihara. Portions created by
' the Initial Developer are Copyright (C) 2003-2004 by Kazuya Ujihara.
' All Rights Reserved.
'
' Contributor(s): all the names of the contributors are added in the source code
' where applicable.

Option Explicit

Private IonQuery As IonFormulaQuery
Private CNQuery As ChemNameQuery
Private CFQuery As ChemFormulaQuery
Private JQuery As JournalQuery
Private RSChangerQuery As ChemRDigitQuery

'********************************************************************************

Public Application As PowerPoint.Application

Dim m_Range As PowerPoint.TextRange
Dim m_Start As Long
Dim m_Length As Long

Public Sub GetSubscript(ByVal Index As Long, ByVal Length As Long, ByRef v As Long)   'v: false=>0, true=> -1, mixture=>9999999
    v = GetTextRange(Index, Length).Font.Subscript
End Sub
Public Sub GetSuperscript(ByVal Index As Long, ByVal Length As Long, ByRef v As Long)   'v: false=>0, true=> -1, mixture=>9999999
    v = GetTextRange(Index, Length).Font.Superscript
End Sub

'returns it did something or not.
Private Function ApplyIt(ByVal GetCommands As Object, Optional ByVal RecoverSelection As Boolean = True) As Boolean
    ApplyIt = False
    
    Dim Runner As CommandRunner
    Set Runner = New CommandRunner
    Set Runner.Executer = Me
    
    Dim Commands As String
    Commands = ""
On Error GoTo Event_Err

    Dim Text As String
On Error GoTo Event_End
    Dim tr As PowerPoint.TextRange
    Set tr = Application.ActiveWindow.Selection.TextRange
    Text = ReplaceString(tr.Text, vbCr & vbLf, vbCr) 'Paragraph separator of PowerPoint is vbCrLf
    m_Start = tr.Start
    m_Length = tr.Length
    Set m_Range = tr.Parent.TextRange
    
    Dim qq As String
    
    qq = GetCommands.GetCommands(Text)
    Commands = XTrim(qq)
    If Commands <> "" Then
        Call Runner.Run(Commands)
        ApplyIt = True
    End If
On Error GoTo Event_Err
On Error GoTo Event_End

On Error GoTo 0
Event_End:
    
    Set Runner = Nothing
    Exit Function

Event_Err:
    AddInErr Err
    Resume Event_End
End Function

Public Sub DeleteText(ByVal Index As Long, ByVal Length As Long)
    GetTextRange(Index, Length).Select
    Application.ActiveWindow.Selection.TextRange.Text = ""
End Sub

Public Sub TypeBackspace()
    m_Range.Characters(Application.ActiveWindow.Selection.TextRange.Start - 1, 1).Select
    Application.ActiveWindow.Selection.TextRange.Text = ""
End Sub

Public Sub TypeParagraph()
    Dim i As Long
    i = GetStartOfSelection
    Application.ActiveWindow.Selection.TextRange.Text = vbCr
    Call SelectRange(i + 1, 0)
End Sub

Public Sub PasteText()
    Application.ActiveWindow.View.Paste
End Sub

Public Sub CopyText(ByVal Index As Long, ByVal Length As Long)
    GetTextRange(Index, Length).Copy
End Sub

Public Sub CutText(ByVal Index As Long, ByVal Length As Long)
    GetTextRange(Index, Length).Cut
    Call SelectRange(Index, 0)
End Sub

Public Function QueryValue(ByVal x As String) As String
    Select Case x
    Case "$CursorPosition"
        QueryValue = Application.ActiveWindow.Selection.TextRange.Start - m_Start
    Case Else
        QueryValue = x
    End Select
End Function

Public Sub MoveCursor(ByVal s As String)
    Dim p As Long
    On Error GoTo 600
    p = s
    GoTo 500
600:
    On Error GoTo 0
    Select Case s
    Case "StartOfSelection"
        p = GetStartOfSelection
    Case "EndOfSelection"
        p = GetEndOfSelection
    Case "PrevChar"
        p = GetStartOfSelection - 1
    Case "NextChar"
        p = GetStartOfSelection + 1
    Case Else
        '
    End Select
500:
    Call SelectRange(p, 0)
End Sub

Private Function GetStartOfSelection() As Long
    GetStartOfSelection = Application.ActiveWindow.Selection.TextRange.Start - m_Start
End Function

Private Function GetEndOfSelection() As Long
    GetEndOfSelection = GetStartOfSelection + Application.ActiveWindow.Selection.TextRange.Length
End Function

Public Sub TypeText(ByVal s As String, Optional ByVal StyleName As String = vbNullString)
    If Len(s) <= 0 Then Exit Sub
    Dim i As Long, l As Long
    i = GetStartOfSelection
    l = Len(s)
    Application.ActiveWindow.Selection.TextRange.Text = s
    Call SetStyle(i, l, StyleName)
    Call SelectRange(i + l, 0)
End Sub

Public Sub ReplaceChar(ByVal Index As Long, ByVal CharCode As Integer)
    GetTextRange(Index, 1).Text = ChrW$(CharCode)
End Sub

Public Sub SetSubscript(ByVal Index As Long, ByVal Length As Long, Optional ByVal v As Long = msoTrue)
    If Length = 0 Then Exit Sub
    GetTextRange(Index, Length).Font.Subscript = v
End Sub
Public Sub SetSuperscript(ByVal Index As Long, ByVal Length As Long, Optional ByVal v As Long = msoTrue)
    If Length = 0 Then Exit Sub
    GetTextRange(Index, Length).Font.Superscript = v
End Sub

Public Sub SetSmall(ByVal Index As Long, ByVal Length As Long, Optional ByVal v As Long = msoTrue)
    If Length = 0 Then Exit Sub
    Call SetStyle(Index, Length, "Small")
End Sub

Public Sub SelectRange(ByVal Index As Long, ByVal Length As Long)
    Call GetTextRange(Index, Length).Select
End Sub

Private Function GetTextRange(ByVal Index As Long, ByVal Length As Long) As PowerPoint.TextRange
    Set GetTextRange = m_Range.Characters(m_Start + Index, Length)
End Function

Public Sub SetStyle(ByVal Index As Long, ByVal Length As Long, ByVal StyleName As String)
    If Length = 0 Then Exit Sub
    Dim Font As PowerPoint.Font
    Set Font = GetTextRange(Index, Length).Font
    Select Case StyleName
    Case vbNullString
        Font.Italic = False
        Font.Bold = False
        Font.Subscript = False
        Font.Superscript = False
    Case "Italic", "Chemical Italic"
        Font.Italic = True
    Case "Bold"
        Font.Bold = True
    Case "Small", "Chemical Small"
        If IsNotMixedSize(m_Range.Font.Size) Then
            Font.Size = Font.Size * 0.8
        End If
    Case Else
        '
    End Select
End Sub

Public Sub ApplyStyle(ByVal StyleName As String)
    Call SetStyle(GetStartOfSelection, GetEndOfSelection - GetStartOfSelection, StyleName)
End Sub

'********************************************************************************
'
Public Sub ApplyIon()
    If IonQuery Is Nothing Then
        Set IonQuery = New IonFormulaQuery
    End If
    Call ApplyIt(IonQuery)
End Sub

Public Sub ApplyChemName()
    If CNQuery Is Nothing Then
        Set CNQuery = New ChemNameQuery
        CNQuery.ItalicCommand = "Chemical Italic"
        CNQuery.SmallCommand = "Small"
    End If
    Call ApplyIt(CNQuery)
End Sub

Public Sub ApplyChemFormula()
    If CFQuery Is Nothing Then
        Set CFQuery = New ChemFormulaQuery
        CFQuery.ItalicCommand = "Chemical Italic"
    End If
    Call ApplyIt(CFQuery)
    
End Sub

Public Sub ApplyJournalRef()
    If JQuery Is Nothing Then Set JQuery = New JournalQuery
    Call ApplyIt(JQuery)
End Sub

Sub ApplyRSChanger()
    If RSChangerQuery Is Nothing Then
        Set RSChangerQuery = New ChemRDigitQuery
        Set RSChangerQuery.FontListener = Me
    End If
    Call ApplyIt(RSChangerQuery)
End Sub

Sub FormatNMRSpec()
    Dim Done As Boolean
    
    Done = FormatAsNMRSpec
    If Done Then Exit Sub
    
    Done = FormatAsNMRSpecR
End Sub

Function FormatAsNMRSpec() As Boolean
    Dim o As NMRSpecFormQuery
    Set o = New NMRSpecFormQuery
    o.SpecFormat = GetDocProperty(NMRSpecFormatPropName, NMRSpecFormatDefault)
    o.TableFormat = GetDocProperty(NMRTableFormatPropName, o.SpecFormat)
    o.JValueStyle = GetDocProperty(JValuesFormatPropName, JValuesFormaDefault)
    FormatAsNMRSpec = ApplyIt(o, False)
End Function

Function FormatAsNMRSpecR() As Boolean
    Dim DefSpecFormat As String
    DefSpecFormat = GetDocProperty(NMRSpecFormatPropName, NMRSpecFormatDefault)
    Dim o As NMRSpecFormRQuery
    Set o = New NMRSpecFormRQuery
    o.TableFormat = GetDocProperty(NMRTableFormatPropName, o.SpecFormat)
    
    FormatAsNMRSpecR = FormatAsNMRSpecRA(DefSpecFormat, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_1H_d_J, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_1H_J_d, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_d_1H_J, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_d_J_1H, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_J_1H_d, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_J_d_1H, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(DefSpecFormat, False, o)
    If FormatAsNMRSpecR Then Exit Function
End Function

Private Function FormatAsNMRSpecRA(ByVal fmt As String, ByVal Strict As Boolean, o As NMRSpecFormRQuery) As Boolean
    o.SpecFormat = fmt
    o.Strict = Strict
    FormatAsNMRSpecRA = ApplyIt(o, False)
End Function

Public Sub ShowNMRSpecSetting()
    Dim frmw As frmNMRSpecFormat
    Set frmw = New frmNMRSpecFormat
    
    frmw.NMRSpecFormat = GetDocProperty(NMRSpecFormatPropName, NMRSpecFormatDefault)
    frmw.JValuesStyle = GetDocProperty(JValuesFormatPropName, JValuesFormaDefault)
    frmw.NMRTableFormat = GetDocProperty(NMRTableFormatPropName, frmw.NMRSpecFormat)

#If VBA = 0 Then
    frmw.Show vbModal
#Else
    frmw.Show
#End If

    If frmw.DialogResult = vbOK Then
        Call SetDocProperty(NMRSpecFormatPropName, frmw.NMRSpecFormat)
        Call SetDocProperty(JValuesFormatPropName, frmw.JValuesStyle)
        Call SetDocProperty(NMRTableFormatPropName, frmw.NMRTableFormat)
    End If
End Sub

''''''''''''''''''''''''''''''''''''''

Public Function GetDocProperty(ByVal PropName As String, ByVal Default As String) As String
    Dim cps As Object 'Office.DocumentProperties
    Set cps = Application.ActivePresentation.CustomDocumentProperties
    GetDocProperty = Default
    On Error Resume Next
    GetDocProperty = cps.Item(PropName).Value
End Function

Public Sub SetDocProperty(ByVal PropName As String, ByVal Value As String)
    Dim cps As Object 'Office.DocumentProperties
    Set cps = Application.ActivePresentation.CustomDocumentProperties
    On Error GoTo 1000
    cps.Item(PropName).Value = Value
2000:
    On Error GoTo 0
    Exit Sub
1000:
    Call cps.Add(PropName, False, msoPropertyTypeString, Value)
    Resume 2000
End Sub

Public Function Supported(ByVal Command As String) As Boolean
    Select Case Command
    Case _
        "ChangeStyleForR", _
        "ApplyStyleForChemName", _
        "ApplyStyleForChemFormula", _
        "ApplyStyleForJournalReference", _
        "ApplyStyleForIon", _
        "ApplyNMRFormat", _
        "ShowNMRFormatSetting"
        Supported = True
    Case Else
        Supported = False
    End Select
End Function



