VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VisioChemFormatter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Copyright 2003-2004 by Kazuya Ujihara <ujihara.jp>.
'
' The contents of this file are subject to the Mozilla Public License Version 1.1
' (the "License"); you may not use this file except in compliance with the License.
' You may obtain a copy of the License at http://www.mozilla.org/MPL/
'
' Software distributed under the License is distributed on an "AS IS" basis,
' WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
' for the specific language governing rights and limitations under the License.
'
' The Original Code is 'ChemFormatter'.
'
' The Initial Developer of the Original Code is Kazuya Ujihara. Portions created by
' the Initial Developer are Copyright (C) 2003-2004 by Kazuya Ujihara.
' All Rights Reserved.
'
' Contributor(s): all the names of the contributors are added in the source code
' where applicable.

Option Explicit

Private IonQuery As IonFormulaQuery
Private CNQuery As ChemNameQuery
Private CFQuery As ChemFormulaQuery
Private JQuery As JournalQuery
Private RSChangerQuery As ChemRDigitQuery

'********************************************************************************

Public Application As Visio.Application
Dim Chars As Visio.Characters
Dim CursorPos As Long
Dim CursorLength As Long
Dim m_Text As String

Public Sub GetSubscript(ByVal Index As Long, ByVal Length As Long, ByRef v As Long)   'v: false=>0, true=> -1, mixture=>9999999
    Call GetTextRange(Index, Length)
    v = Chars.CharPropsRow(Visio.visBiasLetVisioChoose) = Visio.visPosSub
End Sub
Public Sub GetSuperscript(ByVal Index As Long, ByVal Length As Long, ByRef v As Long)   'v: false=>0, true=> -1, mixture=>9999999
    Call GetTextRange(Index, Length)
    v = Chars.CharPropsRow(Visio.visBiasLetVisioChoose) = Visio.visPosSuper
End Sub

'returns it did something or not.
Private Function ApplyIt(ByVal CommandBuilder As Object, Optional ByVal RecoverSelection As Boolean = True) As Boolean
On Error GoTo Event_Err
On Error GoTo Event_End
    Dim Runner As CommandRunner
    Set Runner = New CommandRunner
    Set Runner.Executer = Me

    Dim s As Visio.Shape
    For Each s In Application.ActiveWindow.Selection
        Set Chars = s.Characters
        
        m_Text = Chars.Text
        CursorPos = 0
        CursorLength = Len(m_Text)
    
        Dim Commands As String
        Commands = XTrim(CommandBuilder.GetCommands(Chars.Text))
        If Commands <> "" Then
            Call Runner.Run(Commands)
            ApplyIt = True
        End If
    Next
On Error GoTo 0
Event_End:
    Exit Function

Event_Err:
    AddInErr Err
    Resume Event_End
End Function

Public Sub DeleteText(ByVal Index As Long, ByVal Length As Long)
    GetTextRange(Index, Length).Text = ""
    Call SelectRange(Index, 0)
End Sub

Public Sub TypeBackspace()
    GetTextRange(CursorPos - 1, 1).Text = ""
    Call SelectRange(CursorPos - 1, 0)
End Sub

Public Sub TypeParagraph()
    GetTextRange(CursorPos, 0).Text = vbCr
    Call SelectRange(CursorPos + 1, 0)
End Sub

Public Sub PasteText()
    GetTextRange(CursorPos, 0).Paste
    Call SelectRange(CursorPos, 0)
End Sub

Public Sub CopyText(ByVal Index As Long, ByVal Length As Long)
    GetTextRange(Index, Length).Copy
    Call SelectRange(Index, Length)
End Sub

Public Sub CutText(ByVal Index As Long, ByVal Length As Long)
    GetTextRange(Index, Length).Cut
    Call SelectRange(Index, 0)
End Sub

Public Function QueryValue(ByVal x As String) As String
    Select Case x
    Case "$CursorPosition"
        QueryValue = CursorPos
    Case Else
        QueryValue = x
    End Select
End Function

Public Sub MoveCursor(ByVal s As String)
    Dim p As Long
    On Error GoTo 600
    p = s
    GoTo 500
600:
    On Error GoTo 0
    Select Case s
    Case "StartOfSelection"
        p = CursorPos
    Case "EndOfSelection"
        p = CursorPos + CursorLength
    Case "PrevChar"
        p = CursorPos - 1
    Case "NextChar"
        p = CursorPos + 1
    Case Else
        '
    End Select
500:
    Call SelectRange(p, 0)
End Sub

Public Sub TypeText(ByVal s As String, Optional ByVal StyleName As String = vbNullString)
    Dim l As Long
    l = Len(s)
    If l <= 0 Then Exit Sub
    Dim Range As Publisher.TextRange
    Set Range = GetTextRange(CursorPos, CursorLength)
    Range.Text = s
    Call SetStyle(CursorPos, l, StyleName)
    Call SelectRange(CursorPos + l, 0)
End Sub

Public Sub ReplaceChar(ByVal Index As Long, ByVal CharCode As Integer)
    Call GetTextRange(Index, 1)
    Chars.Text = ChrW$(CharCode)
End Sub

Public Sub SelectRange(ByVal Index As Long, ByVal Length As Long)
    CursorPos = Index
    CursorLength = Length
End Sub

Public Sub SetSubscript(ByVal Index As Long, ByVal Length As Long, Optional ByVal v As Long = msoTrue)
    If Length = 0 Then Exit Sub
    Call GetTextRange(Index, Length)
    Chars.CharProps(Visio.visCharacterPos) = IIf(v, Visio.visPosSub, Visio.visPosNormal)
End Sub
Public Sub SetSuperscript(ByVal Index As Long, ByVal Length As Long, Optional ByVal v As Long = msoTrue)
    If Length = 0 Then Exit Sub
    Call GetTextRange(Index, Length)
    Chars.CharProps(Visio.visCharacterPos) = IIf(v, Visio.visPosSuper, Visio.visPosNormal)
End Sub

Public Sub SetSmall(ByVal Index As Long, ByVal Length As Long, Optional ByVal v As Long = msoTrue)
    If Length = 0 Then Exit Sub
    Call SetStyle(Index, Length, "Small")
End Sub

Private Function GetTextRange(ByVal Index As Long, ByVal Length As Long) As Visio.Characters
    Chars.Begin = Index
    Chars.End = Chars.Begin + Length
    Set GetTextRange = Chars
End Function

Public Sub SetStyle(ByVal Index As Long, ByVal Length As Long, ByVal StyleName As String)
    If Length = 0 Then Exit Sub
    Select Case StyleName
    Case vbNullString
        Call GetTextRange(Index, Length)
        Chars.CharProps(Visio.visCharacterStyle) = 0
    Case "Italic", "Chemical Italic"
        Call GetTextRange(Index, Length)
        Chars.CharProps(Visio.visCharacterStyle) = Visio.visItalic
    Case "Bold"
        Call GetTextRange(Index, Length)
        Chars.CharProps(Visio.visCharacterStyle) = Visio.visBold
    Case "Small", "Chemical Small"
        'not supported. ignore it.
    Case Else
        '
    End Select
End Sub

Public Sub ApplyStyle(ByVal StyleName As String)
    Call SetStyle(CursorPos, CursorLength, StyleName)
End Sub


'********************************************************************************
'
Public Sub ApplyIon()
    If IonQuery Is Nothing Then
        Set IonQuery = New IonFormulaQuery
    End If
    Call ApplyIt(IonQuery)
End Sub

Public Sub ApplyChemName()
    If CNQuery Is Nothing Then
        Set CNQuery = New ChemNameQuery
        CNQuery.ItalicCommand = "Chemical Italic"
        CNQuery.SmallCommand = "Small"
    End If
    Call ApplyIt(CNQuery)
End Sub

Public Sub ApplyChemFormula()
    If CFQuery Is Nothing Then
        Set CFQuery = New ChemFormulaQuery
        CFQuery.ItalicCommand = "Chemical Italic"
    End If
    Call ApplyIt(CFQuery)
    
End Sub

Public Sub ApplyJournalRef()
    If JQuery Is Nothing Then Set JQuery = New JournalQuery
    Call ApplyIt(JQuery)
End Sub

Sub ApplyRSChanger()
    If RSChangerQuery Is Nothing Then
        Set RSChangerQuery = New ChemRDigitQuery
        Set RSChangerQuery.FontListener = Me
    End If
    Call ApplyIt(RSChangerQuery)
End Sub

Sub FormatNMRSpec()
    Dim Done As Boolean
    
    Done = FormatAsNMRSpec
    If Done Then Exit Sub
    
    Done = FormatAsNMRSpecR
End Sub

Function FormatAsNMRSpec() As Boolean
    Dim o As NMRSpecFormQuery
    Set o = New NMRSpecFormQuery
    o.SpecFormat = GetDocProperty(NMRSpecFormatPropName, NMRSpecFormatDefault)
    o.TableFormat = GetDocProperty(NMRTableFormatPropName, o.SpecFormat)
    o.JValueStyle = GetDocProperty(JValuesFormatPropName, JValuesFormaDefault)
    FormatAsNMRSpec = ApplyIt(o, False)
End Function

Function FormatAsNMRSpecR() As Boolean
    Dim DefSpecFormat As String
    DefSpecFormat = GetDocProperty(NMRSpecFormatPropName, NMRSpecFormatDefault)
    Dim o As NMRSpecFormRQuery
    Set o = New NMRSpecFormRQuery
    o.TableFormat = GetDocProperty(NMRTableFormatPropName, o.SpecFormat)
    
    FormatAsNMRSpecR = FormatAsNMRSpecRA(DefSpecFormat, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_1H_d_J, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_1H_J_d, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_d_1H_J, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_d_J_1H, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_J_1H_d, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_J_d_1H, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(DefSpecFormat, False, o)
    If FormatAsNMRSpecR Then Exit Function
End Function

Private Function FormatAsNMRSpecRA(ByVal fmt As String, ByVal Strict As Boolean, o As NMRSpecFormRQuery) As Boolean
    o.SpecFormat = fmt
    o.Strict = Strict
    FormatAsNMRSpecRA = ApplyIt(o, False)
End Function

Public Sub ShowNMRSpecSetting()
    Dim frmw As frmNMRSpecFormat
    Set frmw = New frmNMRSpecFormat
    
    frmw.NMRSpecFormat = GetDocProperty(NMRSpecFormatPropName, NMRSpecFormatDefault)
    frmw.JValuesStyle = GetDocProperty(JValuesFormatPropName, JValuesFormaDefault)
    frmw.NMRTableFormat = GetDocProperty(NMRTableFormatPropName, frmw.NMRSpecFormat)

#If VBA = 0 Then
    frmw.Show vbModal
#Else
    frmw.Show
#End If

    If frmw.DialogResult = vbOK Then
        Call SetDocProperty(NMRSpecFormatPropName, frmw.NMRSpecFormat)
        Call SetDocProperty(JValuesFormatPropName, frmw.JValuesStyle)
        Call SetDocProperty(NMRTableFormatPropName, frmw.NMRTableFormat)
    End If
End Sub

''''''''''''''''''''''''''''''''''''''

Public Function GetDocProperty(ByVal PropName As String, ByVal Default As String) As String
    Err.Raise 1, , "Unsupported."
End Function

Public Sub SetDocProperty(ByVal PropName As String, ByVal Value As String)
    Err.Raise 1, , "Unsupported."
End Sub

Public Function Supported(ByVal Command As String) As Boolean
    Select Case Command
    Case _
        "ApplyStyleForChemName", _
        "ApplyStyleForChemFormula", _
        "ApplyStyleForJournalReference", _
        "ApplyStyleForIon"
        Supported = True
    Case _
        "ChangeStyleForR", _
        "ApplyNMRFormat", _
        "ShowNMRFormatSetting"
        Supported = False
    Case Else
        Supported = False
    End Select
End Function


