VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WordChemFormatter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Copyright 2003-2004 by Kazuya Ujihara <ujihara.jp>.
'
' The contents of this file are subject to the Mozilla Public License Version 1.1
' (the "License"); you may not use this file except in compliance with the License.
' You may obtain a copy of the License at http://www.mozilla.org/MPL/
'
' Software distributed under the License is distributed on an "AS IS" basis,
' WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
' for the specific language governing rights and limitations under the License.
'
' The Original Code is 'ChemFormatter'.
'
' The Initial Developer of the Original Code is Kazuya Ujihara. Portions created by
' the Initial Developer are Copyright (C) 2003-2004 by Kazuya Ujihara.
' All Rights Reserved.
'
' Contributor(s): all the names of the contributors are added in the source code
' where applicable.

Option Explicit

Private IonQuery As IonFormulaQuery
Private CNQuery As ChemNameQuery
Private CFQuery As ChemFormulaQuery
Private JQuery As JournalQuery
Private RSChangerQuery As ChemRDigitQuery

'********************************************************************************

Dim m_Sel As StartNext

Public Application As Word.Application

Private Type StartNext
    StartIndex As Long
    NextIndex As Long
End Type


Public Sub GetSubscript(ByVal Index As Long, ByVal Length As Long, ByRef v As Long)   'v: false=>0, true=> -1, mixture=>9999999
    Call SelectRange(Index, Length)
    v = Application.Selection.Font.Subscript
End Sub
Public Sub GetSuperscript(ByVal Index As Long, ByVal Length As Long, ByRef v As Long)   'v: false=>0, true=> -1, mixture=>9999999
    Call SelectRange(Index, Length)
    v = Application.Selection.Font.Superscript
End Sub

Private Function GetSelectionIndex() As StartNext
    With Application.Selection
        GetSelectionIndex.StartIndex = .Start
        GetSelectionIndex.NextIndex = .End
    End With
End Function

Private Function SetSelectionIndex(Indexes As StartNext)
    Call Application.Selection.SetRange(Indexes.StartIndex, Indexes.NextIndex)
End Function

'returns it did something or not.
Private Function ApplyIt(ByVal GetCommands As Object, Optional ByVal RecoverSelection As Boolean = True) As Boolean
    ApplyIt = False
    
    Dim Runner As CommandRunner
    Set Runner = New CommandRunner
    Set Runner.Executer = Me
    
    Dim Commands As String
    Commands = ""
On Error GoTo Event_Err

    Dim SelectionKeeper As StartNext
    SelectionKeeper = GetSelectionIndex

    Dim Text As String
    If Application.Selection.Type = Word.wdSelectionColumn Then
        Dim qq As String
        
        Dim Cells As Word.Cells
        Set Cells = Application.Selection.Cells
        Dim Cell As Word.Cell
        Dim IsFirst As Boolean: IsFirst = True
        For Each Cell In Cells
            m_Sel.StartIndex = Cell.Range.Start
            m_Sel.NextIndex = Cell.Range.End
            Text = Cell.Range.Text
On Error GoTo Event_End
            qq = GetCommands.GetCommands(Text)
            Commands = XTrim(qq)
            If Commands <> "" Then
                Call Runner.Run(Commands)
                ApplyIt = True
            End If
        Next
    Else
On Error GoTo Event_End
        m_Sel = SelectionKeeper
        Text = Application.Selection.Text
        qq = GetCommands.GetCommands(Text)
        Commands = XTrim(qq)
        If Commands <> "" Then
            Call Runner.Run(Commands)
            ApplyIt = True
        End If
    End If
On Error GoTo Event_Err
On Error GoTo Event_End

On Error GoTo 0
Event_End:
    If RecoverSelection Then Call SetSelectionIndex(SelectionKeeper)
    
    Set Runner = Nothing
    Exit Function

Event_Err:
    AddInErr Err
    Resume Event_End
End Function

Public Sub DeleteText(ByVal Index As Long, ByVal Length As Long)
    Call SelectRange(Index, Length)
    Call Application.Selection.Delete
End Sub

Public Sub TypeBackspace()
    Call Application.Selection.TypeBackspace
End Sub

Public Sub TypeParagraph()
    Call Application.Selection.TypeParagraph
End Sub

Public Sub PasteText()
    Call Application.Selection.Paste
    Call Application.Selection.Font.Reset
End Sub

Public Sub CopyText(ByVal Index As Long, ByVal Length As Long)
    Dim SelectionKeeper As StartNext
    SelectionKeeper = GetSelectionIndex
    Call SelectRange(Index, Length)
    Call Application.Selection.Copy
    Call SetSelectionIndex(SelectionKeeper)
End Sub

Public Sub CutText(ByVal Index As Long, ByVal Length As Long)
    Call SelectRange(Index, Length)
    Call Application.Selection.Cut
End Sub

Public Function QueryValue(ByVal x As String) As String
    Select Case x
    Case "$CursorPosition"
        QueryValue = CStr(Application.Selection.Start - m_Sel.StartIndex)
    Case Else
        QueryValue = x
    End Select
End Function

Public Sub MoveCursor(ByVal s As String)
    Dim p As Long
    On Error GoTo 600
    p = CLng(s) + m_Sel.StartIndex
    GoTo 500
600:
    On Error GoTo 0
    Select Case s
    Case "StartOfSelection"
        GoTo 700    ' do nothing
    Case "EndOfSelection"
        p = Application.Selection.End
    Case "PrevChar"
        p = Application.Selection.Start - 1
    Case "NextChar"
        p = Application.Selection.Start + 1
    Case Else
        '
    End Select
500:
    Call Application.Selection.SetRange(p, p)
700:
    Exit Sub
End Sub

Public Sub TypeText(ByVal s As String, Optional ByVal StyleName As String = vbNullString)
    If Len(s) <= 0 Then Exit Sub
    Dim CurrPos As Long: CurrPos = Application.Selection.Start
    Call Application.Selection.TypeText(s)
    Dim EPos As Long: EPos = Application.Selection.Start
    Call Application.Selection.SetRange(CurrPos, EPos)
    If StyleName <> vbNullString Then
        Application.Selection.Style = ForceGetStyle(StyleName)
    Else
        Application.Selection.Font.Reset
    End If
    Call Application.Selection.SetRange(EPos, EPos)
    Application.Selection.Font.Reset
End Sub

Public Sub ReplaceChar(ByVal Index As Long, ByVal CharCode As Integer)
    Call SelectRange(Index, 1)
    Application.Selection.Text = ChrW$(CharCode)
End Sub

Public Sub SetSubscript(ByVal Index As Long, ByVal Length As Long, Optional ByVal v As Long = msoTrue)
    If Length = 0 Then Exit Sub
    Call SelectRange(Index, Length)
    Application.Selection.Font.Subscript = v
End Sub
Public Sub SetSuperscript(ByVal Index As Long, ByVal Length As Long, Optional ByVal v As Long = msoTrue)
    If Length = 0 Then Exit Sub
    Call SelectRange(Index, Length)
    Application.Selection.Font.Superscript = v
End Sub

Public Sub SetSmall(ByVal Index As Long, ByVal Length As Long, Optional ByVal v As Long = msoTrue)
    If Length = 0 Then Exit Sub
#If False Then
    Call SetStyle(Index, Length, "Chemical Small")
#Else
    If Length < m_Sel.NextIndex - m_Sel.StartIndex Then 'Don't change the font size when 'D', 'L' or 'DL' is selected.
        Dim Size As Single
        Call SelectRange(Index + Length, 1)
        Size = Application.Selection.Font.Size

        Call SetStyle(Index, Length, "Chemical Small")
        If IsNotMixedSize(Size) Then
            Call SelectRange(Index, Length)
            Application.Selection.Font.Size = Size * 0.8
        End If
    End If
#End If
End Sub

Public Sub SelectRange(ByVal Index As Long, ByVal Length As Long)
    Call Application.Selection.SetRange(m_Sel.StartIndex + Index, m_Sel.StartIndex + Index + Length)
End Sub

Public Sub SetStyle(ByVal Index As Long, ByVal Length As Long, ByVal StyleName As String)
    If Length = 0 Then Exit Sub
    Call SelectRange(Index, Length)
    Call ApplyStyle(StyleName)
End Sub

Public Sub ApplyStyle(ByVal StyleName As String)
    Application.Selection.Style = ForceGetStyle(StyleName)
End Sub

Private Function RegisterStyles()
    Dim Style As Word.Style
    Dim Added As Boolean
    On Error Resume Next 'error is occured when style type is mismatch.
    Set Style = GetOrAddStyle("Bold", Added, wdStyleTypeCharacter)
    If Added Then Style.Font.Bold = True
    
    Set Style = GetOrAddStyle("Italic", Added, wdStyleTypeCharacter)
    If Added Then Style.Font.Italic = True
    
    Set Style = GetOrAddStyle("Chemical Italic", Added, wdStyleTypeCharacter)
    If Added Then Style.BaseStyle = ActiveDocument.Styles("Italic")
    
    Set Style = GetOrAddStyle("Chemical Small", Added, wdStyleTypeCharacter)
    
    Set Style = GetOrAddStyle("NMR Spec Table", Added, wdStyleTypeParagraph)
    If Added Then
        Style.ParagraphFormat.TabStops.ClearAll
    End If
    On Error GoTo 0
End Function

Private Function GetOrAddStyle(ByVal Name As String, ByRef Added As Boolean, ByVal StyleType As Long) As Word.Style 'StyleType As WdStyleType
    Added = False
    Dim Style As Word.Style
    Set Style = GetStyle(Name)
    If Style Is Nothing Then
        Set Style = AddStyle(Name, StyleType)
        Added = True
    End If
    Set GetOrAddStyle = Style
End Function

Private Function ForceGetStyle(ByVal Name As String) As Word.Style
    Dim Style As Style
    Set Style = GetStyle(Name)
    If Style Is Nothing Then
        Call RegisterStyles
        Set ForceGetStyle = ActiveDocument.Styles(Name)
    Else
        Set ForceGetStyle = Style
    End If
End Function

Private Function GetStyle(ByVal Name As String) As Word.Style
On Error Resume Next
    Dim Style As Word.Style
    Set Style = ActiveDocument.Styles(Name)
    If Err.Number = 5941 Then Set Style = Nothing
On Error GoTo 0
    Set GetStyle = Style
End Function

Private Function AddStyle(ByVal Name As String, ByVal StyleType As Long) As Word.Style 'StyleType As WdStyleType
    Set AddStyle = Application.ActiveDocument.Styles.Add(Name, StyleType)
    If StyleType = wdStyleTypeCharacter Then
        AddStyle.BaseStyle = ActiveDocument.Styles(wdStyleDefaultParagraphFont)
    End If
End Function

'********************************************************************************
'
Public Sub ApplyIon()
    If IonQuery Is Nothing Then
        Set IonQuery = New IonFormulaQuery
    End If
    Call ApplyIt(IonQuery)
End Sub

Public Sub ApplyChemName()
    If CNQuery Is Nothing Then
        Set CNQuery = New ChemNameQuery
        CNQuery.ItalicCommand = "Chemical Italic"
        CNQuery.SmallCommand = "Small"
    End If
    Call ApplyIt(CNQuery)
End Sub

Public Sub ApplyChemFormula()
    If CFQuery Is Nothing Then
        Set CFQuery = New ChemFormulaQuery
        CFQuery.ItalicCommand = "Chemical Italic"
    End If
    Call ApplyIt(CFQuery)
    
End Sub

Public Sub ApplyJournalRef()
    If JQuery Is Nothing Then Set JQuery = New JournalQuery
    Call ApplyIt(JQuery)
End Sub

Sub ApplyRSChanger()
    If RSChangerQuery Is Nothing Then
        Set RSChangerQuery = New ChemRDigitQuery
        Set RSChangerQuery.FontListener = Me
    End If
    Call ApplyIt(RSChangerQuery)
End Sub

Sub FormatNMRSpec()
    Dim l0 As Long, l1 As Long
    l0 = Application.Selection.Start
    l1 = Application.Selection.End
    
    Dim Done As Boolean
    
    Done = FormatAsNMRSpec
    If Done Then Exit Sub
    
    Call Application.Selection.SetRange(l0, l1)
    Done = FormatAsNMRSpecR
End Sub

Function FormatAsNMRSpec() As Boolean
    Dim o As NMRSpecFormQuery
    Set o = New NMRSpecFormQuery
    o.SpecFormat = GetDocProperty(NMRSpecFormatPropName, NMRSpecFormatDefault)
    o.TableFormat = GetDocProperty(NMRTableFormatPropName, o.SpecFormat)
    o.JValueStyle = GetDocProperty(JValuesFormatPropName, JValuesFormaDefault)
    FormatAsNMRSpec = ApplyIt(o, False)
End Function

Function FormatAsNMRSpecR() As Boolean
    Dim DefSpecFormat As String
    DefSpecFormat = GetDocProperty(NMRSpecFormatPropName, NMRSpecFormatDefault)
    Dim o As NMRSpecFormRQuery
    Set o = New NMRSpecFormRQuery
    o.TableFormat = GetDocProperty(NMRTableFormatPropName, o.SpecFormat)
    
    FormatAsNMRSpecR = FormatAsNMRSpecRA(DefSpecFormat, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_1H_d_J, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_1H_J_d, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_d_1H_J, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_d_J_1H, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_J_1H_d, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(NMRSpecFormat_J_d_1H, True, o)
    If FormatAsNMRSpecR Then Exit Function
    FormatAsNMRSpecR = FormatAsNMRSpecRA(DefSpecFormat, False, o)
    If FormatAsNMRSpecR Then Exit Function
End Function

Private Function FormatAsNMRSpecRA(ByVal fmt As String, ByVal Strict As Boolean, o As NMRSpecFormRQuery) As Boolean
    o.SpecFormat = fmt
    o.Strict = Strict
    FormatAsNMRSpecRA = ApplyIt(o, False)
End Function

Public Sub ShowNMRSpecSetting()
    Dim frmw As frmNMRSpecFormat
    Set frmw = New frmNMRSpecFormat
    
    frmw.NMRSpecFormat = GetDocProperty(NMRSpecFormatPropName, NMRSpecFormatDefault)
    frmw.JValuesStyle = GetDocProperty(JValuesFormatPropName, JValuesFormaDefault)
    frmw.NMRTableFormat = GetDocProperty(NMRTableFormatPropName, frmw.NMRSpecFormat)

#If VBA = 0 Then
    frmw.Show vbModal
#Else
    frmw.Show
#End If

    If frmw.DialogResult = vbOK Then
        Call SetDocProperty(NMRSpecFormatPropName, frmw.NMRSpecFormat)
        Call SetDocProperty(JValuesFormatPropName, frmw.JValuesStyle)
        Call SetDocProperty(NMRTableFormatPropName, frmw.NMRTableFormat)
    End If
End Sub

Public Function GetDocProperty(ByVal PropName As String, ByVal Default As String) As String
    Dim cps As Object 'Office.DocumentProperties
    Set cps = Application.ActiveDocument.CustomDocumentProperties
    GetDocProperty = Default
    On Error Resume Next
    GetDocProperty = cps.Item(PropName).Value
End Function

Public Sub SetDocProperty(ByVal PropName As String, ByVal Value As String)
    Dim cps As Object 'Office.DocumentProperties
    Set cps = Application.ActiveDocument.CustomDocumentProperties
    On Error GoTo 1000
    cps.Item(PropName).Value = Value
2000:
    On Error GoTo 0
    Exit Sub
1000:
    Call cps.Add(PropName, False, msoPropertyTypeString, Value)
    Resume 2000
End Sub

Public Function Supported(ByVal Command As String) As Boolean
    Select Case Command
    Case _
        "ChangeStyleForR", _
        "ApplyStyleForChemName", _
        "ApplyStyleForChemFormula", _
        "ApplyStyleForJournalReference", _
        "ApplyStyleForIon", _
        "ApplyNMRFormat", _
        "ShowNMRFormatSetting"
        Supported = True
    Case Else
        Supported = False
    End Select
End Function

