VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ChemNameQuery"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Copyright 2003-2004 by Kazuya Ujihara <ujihara.jp>.
'
' The contents of this file are subject to the Mozilla Public License Version 1.1
' (the "License"); you may not use this file except in compliance with the License.
' You may obtain a copy of the License at http://www.mozilla.org/MPL/
'
' Software distributed under the License is distributed on an "AS IS" basis,
' WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
' for the specific language governing rights and limitations under the License.
'
' The Original Code is 'ChemFormatter'.
'
' The Initial Developer of the Original Code is Kazuya Ujihara. Portions created by
' the Initial Developer are Copyright (C) 2003-2004 by Kazuya Ujihara.
' All Rights Reserved.
'
' Contributor(s): all the names of the contributors are added in the source code
' where applicable.
Option Explicit

Private CIPQuery As ChemKeywordsQuery
Private CSQuery As ChemKeywordsQuery
Private CAQuery As ChemKeywordsQuery
Private CSmQuery As ChemKeywordsQuery

Public ItalicCommand As String
Public SmallCommand As String

Function GetCommands(ByVal Text As String) As String
    Text = NormalizeString(Text) & " " 'Add stopper

    If CIPQuery Is Nothing Then
        Set CIPQuery = GetChemItalicPrefixesQuery
        CIPQuery.Command = ItalicCommand
        Set CSQuery = GetChemStereoQuery
        CSQuery.Command = ItalicCommand
        Set CAQuery = GetChemAtomQuery
        CAQuery.Command = ItalicCommand
        Set CSmQuery = GetChemSmallQuery
        CSmQuery.Command = SmallCommand
    End If

    Dim UText() As Integer
    Call StrToI16Array(Text, UText)
    GetCommands = ""
    GetCommands = GetCommands & CIPQuery.GetCommands(UText)
    GetCommands = GetCommands & CSQuery.GetCommands(UText)
    GetCommands = GetCommands & CAQuery.GetCommands(UText)
    GetCommands = GetCommands & CSmQuery.GetCommands(UText)
End Function

Private Sub Class_Initialize()
    ItalicCommand = "Italic"
    SmallCommand = "Small"
End Sub

