VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ChemRDigitQuery"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Copyright 2003-2004 by Kazuya Ujihara <ujihara.jp>.
'
' The contents of this file are subject to the Mozilla Public License Version 1.1
' (the "License"); you may not use this file except in compliance with the License.
' You may obtain a copy of the License at http://www.mozilla.org/MPL/
'
' Software distributed under the License is distributed on an "AS IS" basis,
' WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
' for the specific language governing rights and limitations under the License.
'
' The Original Code is 'ChemFormatter'.
'
' The Initial Developer of the Original Code is Kazuya Ujihara. Portions created by
' the Initial Developer are Copyright (C) 2003-2004 by Kazuya Ujihara.
' All Rights Reserved.
'
' Contributor(s): all the names of the contributors are added in the source code
' where applicable.

Option Explicit

Private SubscriptQuery As ChemSubscriptQuery

Const tmUnknown = 0
Const tmToNormal = 1
Const tmToSubscript = 2
Const tmToSuperscript = 3
Private ChangeForChemR_Mode As Long

Public FontListener As Object

Public Function QueryValue(ByVal x As String) As String
    QueryValue = x
End Function

Public Sub SetSubscript(ByVal Index As Long, ByVal Length As Long, Optional ByVal v As Long = msoTrue)
    If ChangeForChemR_Mode = tmUnknown Then
        Dim FSubS As Long
        Dim FSupS As Long

        Call FontListener.GetSubscript(Index, Length, FSubS)
        Call FontListener.GetSuperscript(Index, Length, FSupS)

        Dim SubS As Boolean
        Dim SupS As Boolean
        If FSubS <> 0 And FSubS <> -1 Then
            SubS = False
            SupS = False
        Else
            SubS = FSubS <> 0
            SupS = FSupS <> 0
        End If

        If Not SubS And Not SupS Then
            ChangeForChemR_Mode = tmToSubscript
        ElseIf SubS Then
            ChangeForChemR_Mode = tmToSuperscript
        ElseIf SupS Then
            ChangeForChemR_Mode = tmToNormal
        Else
            Err.Raise 1, , "Internal Error."
        End If
    End If

End Sub

Function GetCommands(ByVal Text As String) As String
    Text = NormalizeString(Text) & " "
    
    If SubscriptQuery Is Nothing Then
        Set SubscriptQuery = New ChemSubscriptQuery
    End If

    ChangeForChemR_Mode = tmUnknown

    Dim UText() As Integer
    Call StrToI16Array(Text, UText)

    GetCommands = SubscriptQuery.GetCommands(UText)

    Dim Runner As CommandRunner
    Set Runner = New CommandRunner
    Set Runner.Executer = Me
    Runner.IgnoreError = True
    Call Runner.Run(GetCommands)
    
    Dim ScriptCommand As String
    Select Case ChangeForChemR_Mode
    Case tmToNormal
        ScriptCommand = "NormalScript"
    Case tmToSubscript
        ScriptCommand = "Subscript"
    Case tmToSuperscript
        ScriptCommand = "Superscript"
    Case Else
        Err.Raise 1, , "Internal Error."
    End Select
    GetCommands = ReplaceString(GetCommands, "Subscript" & vbLf, ScriptCommand & vbLf) 'It will be able to fail.
End Function


