VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CommandRunner"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Copyright 2004 by Kazuya Ujihara <ujihara.jp>.
'
' The contents of this file are subject to the Mozilla Public License Version 1.1
' (the "License"); you may not use this file except in compliance with the License.
' You may obtain a copy of the License at http://www.mozilla.org/MPL/
'
' Software distributed under the License is distributed on an "AS IS" basis,
' WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
' for the specific language governing rights and limitations under the License.
'
' The Original Code is 'ChemFormatter'.
'
' The Initial Developer of the Original Code is Kazuya Ujihara. Portions created by
' the Initial Developer are Copyright (C) 2004 by Kazuya Ujihara.
' All Rights Reserved.
'
' Contributor(s): all the names of the contributors are added in the source code
' where applicable.

'2004-06-03 Separated from WordChemFormatter and based on P-code language.

Option Explicit

Public Executer As Object
Public IgnoreError As Boolean

Dim Stack(100) As String
Dim StackPtr As Long
Dim p_a As Variant, p_b As Variant

Private Sub Push(ByVal x As String)
    Stack(StackPtr) = Executer.QueryValue(x)
    StackPtr = StackPtr + 1
End Sub

Private Function Pop() As String
    StackPtr = StackPtr - 1
    Pop = Stack(StackPtr)
End Function

Private Sub Pop2D()
    p_b = CDbl(Pop())
    p_a = CDbl(Pop())
End Sub

Private Sub Pop2S()
    p_b = CStr(Pop())
    p_a = CStr(Pop())
End Sub

Public Sub Run(ByVal Commands As String)
    StackPtr = 0

    Dim Coms() As String
    Call SplitWord(Commands, vbLf, Coms)
    
On Error GoTo 1000
    
    Dim i As Long
    For i = 0 To UBound(Coms)
        Dim Verb As String
        Verb = Coms(i)
        If Left$(Verb, 1) = LITERAL_INDICATOR Then
            Call Push(Mid$(Verb, 2))
        Else
            Select Case Verb
            Case "Pop"
                Call Pop
            Case "Plus"
                Call Pop2D
                Call Push(p_a + p_b)
            Case "Minus"
                Call Pop2D
                Call Push(p_a - p_b)
            Case "Inv"
                Call Push(-CDbl(Pop()))
            Case "NormalScript"
                Call Pop2D
                Call Executer.SetSubscript(p_a, p_b, False)
                Call Executer.SetSuperscript(p_a, p_b, False)
            Case "Subscript"
                Call Pop2D
                Call Executer.SetSubscript(p_a, p_b, False)
                Call Executer.SetSuperscript(p_a, p_b, False)
                Call Executer.SetSubscript(p_a, p_b, True)
            Case "Superscript"
                Call Pop2D
                Call Executer.SetSubscript(p_a, p_b, False)
                Call Executer.SetSuperscript(p_a, p_b, False)
                Call Executer.SetSuperscript(p_a, p_b, True)
            Case "Small"
                Call Pop2D
                Call Executer.SetSmall(p_a, p_b)
            Case "Italic", "Bold", "Chemical Italic", "Chemical Small"
                Call Pop2D
                Call Executer.SetStyle(p_a, p_b, Verb)
            Case "ApplyStyle"
                Call Executer.ApplyStyle(CStr(Pop()))
            Case "ReplaceChar"
                Call Pop2S
                Call Executer.ReplaceChar(p_a, p_b)
            Case "TypeBackspace"
                Call Executer.TypeBackspace
            Case "TypeParagraph"
                Call Executer.TypeParagraph
            Case "TypeText"
                Call Executer.TypeText(Pop(), vbNullString)
            Case "TypeStyledText"
                Call Pop2S
                Call Executer.TypeText(p_a, p_b)
            Case "GoTo"
                Call Executer.MoveCursor(Pop())
            Case "Copy"
                Call Pop2D
                Call Executer.CopyText(p_a, p_b)
            Case "Cut"
                Call Pop2D
                Call Executer.CutText(p_a, p_b)
            Case "Paste"
                Call Executer.PasteText
            Case "Delete"
                Call Pop2D
                Call Executer.DeleteText(p_a, p_b)
            Case "Select"
                Call Pop2D
                Call Executer.SelectRange(p_a, p_b)
            Case ""
                'do nothing
            Case Else
    #If OLDVB = 0 Then
                Debug.Assert False
    #End If
            End Select
        End If
    Next
    
On Error GoTo 0
    Exit Sub
    
1000:
    If IgnoreError Then
        Resume Next
    Else
        Err.Raise Err.Number, Err.Source, Err.Description, Err.HelpFile, Err.HelpContext
    End If
End Sub

Private Sub Class_Initialize()
    IgnoreError = False
End Sub

Private Sub Class_Terminate()
    Set Executer = Nothing
End Sub

