VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "JournalQuery"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Copyright 2003-2004 by Kazuya Ujihara <ujihara.jp>.
'
' The contents of this file are subject to the Mozilla Public License Version 1.1 ' (the "License"); you may not use this file except in compliance with the License.
' You may obtain a copy of the License at http://www.mozilla.org/MPL/ '
' Software distributed under the License is distributed on an "AS IS" basis, ' WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License ' for the specific language governing rights and limitations under the License.
'
' The Original Code is 'ChemFormatter'.
'
' The Initial Developer of the Original Code is Kazuya Ujihara. Portions created by ' the Initial Developer are Copyright (C) 2003-2004 by Kazuya Ujihara.
' All Rights Reserved.
'
' Contributor(s): all the names of the contributors are added in the source code ' where applicable.

Option Explicit

Function GetCommands(ByVal Text As String) As String
    Dim i As Long, j As Long, k As Long
    GetCommands = ""

    Dim NameIndex As Long, NameLength As Long
    Dim YearIndex As Long, YearLength As Long
    Dim VolumeIndex As Long, VolumeLength As Long
    
    Text = NormalizeString(Text) & " " 'Add stopper
#If True Then
    Dim UText() As Integer
    Call StrToI16Array(Text, UText)

    Dim l As Long
    l = UBound(UText)
    For i = 0 To l
        Dim cc As Integer
        cc = UText(i)
        If Unicode_BigA <= cc And cc <= Unicode_BigZ Then
            For j = i + 1 To l
                cc = UText(j)
                If Not (UnicodeIsAlNum(cc) Or Unicode_Period = cc Or Unicode_Space = cc) Then
                    GoTo 100
                End If
            Next
            'no null terminate
            GoTo 200
100:
            If cc <> Unicode_Comma Then GoTo 120
            'a(i) to a(j-1) are word at this point.
            
            If j - i < 5 Then GoTo 300
            cc = UText(j - 5)
            If cc <> Unicode_Space Then GoTo 300
            For k = j - 4 To j - 1
                cc = UText(k)
                If Not (Unicode_0 <= cc And Unicode_0 <= cc) Then
                    GoTo 300
                End If
            Next
            GoTo 310
300:
            NameIndex = i
            NameLength = j - i
            GoTo 130
310:
            NameIndex = i
            NameLength = j - i - 5
            YearIndex = j - 4
            YearLength = 4
            j = j + 1: cc = UText(j)
            If cc <> Unicode_Space Then GoTo 120
            j = j + 1
            Dim s As String
            s = GetIntegerString(UText, j)
            
            k = j + Len(s)
            'j to k-1 is numeric
            cc = UText(k)
            Select Case cc
            Case Unicode_SmallOpeningParenthesis
                'J. Am. Chem. Soc. 2003, 123(45), 6789. --- 2003 is bold. 123 is italic.
                'J. Am. Chem. Soc. 2003, (45), 6789. --- 2003 is bold.
                VolumeIndex = j
                VolumeLength = k - j
                k = k + 1
                s = GetIntegerString(UText, k)
                If s = "" Then GoTo 120
                k = k + Len(s): cc = UText(k)
                If cc <> Unicode_SmallClosingParenthesis Then GoTo 120
                k = k + 1: cc = UText(k)
                If cc <> Unicode_Comma Then GoTo 120
                k = k + 1: cc = UText(k)
                If cc <> Unicode_Space Then GoTo 120
                k = k + 1
                s = GetIntegerString(UText, k)
                If s = "" Then GoTo 120
                GoTo 3000
            Case Unicode_Comma
                'J. Chem. Soc. Chem. Commun. 2003, 123, 1234. --- 2003 is bold. 123 is italic.
                VolumeIndex = j
                VolumeLength = k - j
                If VolumeLength <= 0 Then GoTo 120
                k = k + 1: cc = UText(k)
                If cc <> Unicode_Space Then GoTo 120
                k = k + 1
                s = GetIntegerString(UText, k)
                If Len(s) = 0 Then GoTo 120
                GoTo 3000
            Case Else
                'J. Chem. Soc. Chem. Commun. 2003, 1234. --- 2003 is bold.
                VolumeIndex = j
                VolumeLength = 0
                If k - j <= 0 Then GoTo 120
                GoTo 3000
            End Select
            GoTo 120
130:
            'Type1
            'J. Am. Chem. Soc., 123(5), 4567 (1985). --- 123 is bold
            'J. Am. Chem. Soc., 123(5), 4567-4570 (1985). --- 123 is bold
            'J. Am. Chem. Soc., (5), 4567 (1985). --- no style
            'J. Am. Chem. Soc., 123, 4567 (1985). --- 123 is bold
            'Type2
            'J. Am. Chem. Soc., 4567 (1985).
            'J. Am. Chem. Soc., 4567-4570 (1985).
            'Type3
            'J. Am. Chem. Soc., 2003, 123(5), 6789. --- 123 is bold
            'J. Am. Chem. Soc., 2003, (5), 6789. --- no style
            'J. Am. Chem. Soc., 2003, 123, 6789. --- 123 is bold
            'Type4
            'J. Am. Chem. Soc., 2003, 6789.
            
            j = j + 1
            cc = UText(j): j = j + 1
            If cc <> Unicode_Space Then GoTo 120
            
            Dim pp1 As Long, pp2 As Long
            Dim pl1 As Long, pl2 As Long
            Dim ss1 As String, ss2 As String, ss3 As String
            Dim nn As Long, HasP As Boolean
            ss1 = GetPwithN(UText, j, nn, HasP)
            If ss1 = "" Then GoTo 120
            pp1 = j
            pl1 = nn
            j = j + Len(ss1)
            cc = UText(j): j = j + 1
            If cc = Unicode_Space Then
                'J. Am. Chem. Soc., 4567 (1985).
                If HasP Then GoTo 120
                pp2 = pp1
                pl2 = pl1
                pl1 = 0
            ElseIf cc = Unicode_Minus Then
                'J. Am. Chem. Soc., 4567-4570 (1985).
                If HasP Then GoTo 120
                ss1 = GetIntegerString(UText, j)
                j = j + Len(ss1)
                cc = UText(j): j = j + 1
                If cc <> Unicode_Space Then GoTo 120
                pp2 = pp1
                pl2 = pl1
                pl1 = 0
            ElseIf cc = Unicode_Comma Then
                cc = UText(j): j = j + 1
                If Not cc = Unicode_Space Then GoTo 120
                If Not HasP And pl1 = 4 Then
                    If Left$(ss1, 2) = "19" Or Left$(ss1, 2) = "20" Then
                        'J. Am. Chem. Soc., 2003, 123(5), 6789
                        'J. Am. Chem. Soc., 2003, (5), 6789
                        'J. Am. Chem. Soc., 2003, 123, 6789
                        'J. Am. Chem. Soc., 2003, 6789.

                        ss2 = GetPwithN(UText, j, nn, HasP)
                        If ss2 = "" Then GoTo 600 'J. Am. Chem. Soc., 4567, (1985).
                        pp2 = j
                        pl2 = nn
                        j = j + Len(ss2)
                        cc = UText(j): j = j + 1
                        If Not cc = Unicode_Comma Then GoTo 120
                        cc = UText(j): j = j + 1
                        If Not cc = Unicode_Space Then GoTo 120
                        ss3 = GetIntegerString(UText, j)
                        If ss3 = "" Then GoTo 120
                        
                        VolumeIndex = pp2
                        VolumeLength = pl2
                        GoTo 3100
                    End If
                End If
600:
                'J. Am. Chem. Soc., 123(5), 4567 (1985). --- 123 is bold
                'J. Am. Chem. Soc., 123(5), 4567-4570 (1985). --- 123 is bold
                'J. Am. Chem. Soc., (5), 4567 (1985). --- no style
                'J. Am. Chem. Soc., 123, 4567 (1985). --- 123 is bold
                ss2 = GetIntegerString(UText, j)
                If ss2 = "" Then GoTo 120
                pp2 = j
                pl2 = Len(ss2)
                j = j + Len(ss2)
                cc = UText(j): j = j + 1
                If cc = Unicode_Minus Then
                    'J. Am. Chem. Soc., 123(5), 4567-4570 (1985). --- 123 is bold
                    ss2 = GetIntegerString(UText, j)
                    If ss2 = "" Then GoTo 120
                    j = j + Len(ss2)
                    cc = UText(j): j = j + 1
                End If
                If Not cc = Unicode_Space Then
                    GoTo 120
                End If
            End If
            ss3 = GetParenthesisNumber(UText, j)
            If Not (Len(ss3) = "6" And (Mid$(ss3, 2, 2) = "19" Or Mid$(ss3, 2, 2) = "20")) Then GoTo 120
            VolumeIndex = pp1
            VolumeLength = pl1
            GoTo 3100
120:
            i = j
        End If
110:
    Next
#Else
    Dim RegExp As Object 'RegExp
    Dim Matches As Object 'MatchCollection
    Dim Match As Object 'Match
    Dim SubMatches As Object 'SubMatches
    
    Set RegExp = CreateRegExp
    
    RegExp.Pattern = "(\b[A-Z][A-Za-z0-9\.\ ]*)\ (\d{4})\,\ (\d+)(\(\d+\)|)\,\ (\d+)(\-\d+|)\.?"   'J. Am. Chem. Soc. 2003, 56(2), 345-455.
    Set Matches = RegExp.Execute(Text)
    If Matches.Count > 0 Then
        Set Match = Matches.Item(0)
        Set SubMatches = Match.SubMatches
        NameIndex = Match.FirstIndex: NameLength = Len(SubMatches.Item(0))
        YearIndex = NameIndex + NameLength + 1: YearLength = Len(SubMatches.Item(1))
        VolumeIndex = YearIndex + YearLength + 2: VolumeLength = Len(SubMatches.Item(2))
        GoTo 3000
    End If
    
    RegExp.Pattern = "(\b[A-Z][A-Za-z0-9\.\ ]*)\,\ (\d{4})\,\ (\d+)(\(\d+\)|)\,\ (\d+)(\-\d+|)\.?"   'J. Am. Chem. Soc., 2003, 56(2), 345-455.
    Set Matches = RegExp.Execute(Text)
    If Matches.Count > 0 Then
        Set Match = Matches.Item(0)
        Set SubMatches = Match.SubMatches
        NameIndex = Match.FirstIndex: NameLength = Len(SubMatches.Item(0))
        YearIndex = NameIndex + NameLength + 2: YearLength = Len(SubMatches.Item(1))
        VolumeIndex = YearIndex + YearLength + 2: VolumeLength = Len(SubMatches.Item(2))
        GoTo 3100
    End If
    
    RegExp.Pattern = "(\b[A-Z][A-Za-z0-9\.\ ]*)\ (\d+)(\(\d+\)|)\,\ (\d{4})\,\ (\d+)(\-\d+|)\.?"   'J. Am. Chem. Soc. 56(2), 2003, 345-455.
    Set Matches = RegExp.Execute(Text)
    If Matches.Count > 0 Then
        Set Match = Matches.Item(0)
        Set SubMatches = Match.SubMatches
        NameIndex = Match.FirstIndex: NameLength = Len(SubMatches.Item(0))
        VolumeIndex = NameIndex + NameLength + 1: VolumeLength = Len(SubMatches.Item(1))
        YearIndex = VolumeIndex + VolumeLength + Len(SubMatches.Item(2)) + 2: YearLength = Len(SubMatches.Item(3))
        GoTo 3100
    End If
    
    RegExp.Pattern = "(\b[A-Z][A-Za-z0-9\.\ ]*)\ (\d{4})\,\ (\(\d+\)\,\ )?(\d+)(\-\d+|)\.?"   'Tetrahedron Lett. 2003, 345-455.
    Set Matches = RegExp.Execute(Text)
    If Matches.Count > 0 Then
        Set Match = Matches.Item(0)
        Set SubMatches = Match.SubMatches
        NameIndex = Match.FirstIndex: NameLength = Len(SubMatches.Item(0))
        YearIndex = NameIndex + NameLength + 1: YearLength = Len(SubMatches.Item(1))
        VolumeIndex = 0: VolumeLength = 0
        GoTo 3000
    End If
    
    RegExp.Pattern = "(\b[A-Z][A-Za-z0-9\.\ ]*)\,\ (\d+)(\(\d+\)|)\,\ (\d+)(\-\d+|)\ ?(\(\d{4}\))\.?"   'J. Am. Chem. Soc., 56(2), 345-455 (2003).
    Set Matches = RegExp.Execute(Text)
    If Matches.Count > 0 Then
        Set Match = Matches.Item(0)
        Set SubMatches = Match.SubMatches
        NameIndex = Match.FirstIndex: NameLength = Len(SubMatches.Item(0))
        VolumeIndex = NameIndex + NameLength + 2: VolumeLength = Len(SubMatches.Item(1))
        GoTo 3100
    End If
#End If
    GoTo 200
3000:
    If NameLength > 0 Then GetCommands = GetCommands & MakeCommand2("Italic", NameIndex, NameLength)
    If YearLength > 0 Then GetCommands = GetCommands & MakeCommand2("Bold", YearIndex, YearLength)
    If VolumeLength > 0 Then GetCommands = GetCommands & MakeCommand2("Italic", VolumeIndex, VolumeLength)
    GoTo 200
3100:
    If NameLength > 0 Then GetCommands = GetCommands & MakeCommand2("Italic", NameIndex, NameLength)
    If VolumeLength > 0 Then GetCommands = GetCommands & MakeCommand2("Bold", VolumeIndex, VolumeLength)
    GoTo 200
200:
End Function

Private Function GetIntegerString(UText() As Integer, ByVal Start As Long) As String
    Dim i As Long
    For i = Start To UBound(UText)
        If Not UnicodeIsDigit(UText(i)) Then GoTo 100
    Next
100:
    GetIntegerString = I16ArrayToStr(UText, Start, i - Start)
End Function

Private Function GetParenthesisNumber(UText() As Integer, ByVal Start As Long) As String
    On Error GoTo 1000
    Dim i As Long
    i = Start
    Dim cc As Long
    cc = UText(i)
    If Not (cc = Unicode_SmallOpeningParenthesis) Then GoTo 100
    i = i + 1
    Dim sn As String
    sn = GetIntegerString(UText, i)
    If sn = "" Then
        i = Start
        GoTo 100
    End If
    i = i + Len(sn)
    cc = UText(i)
    If Not (cc = Unicode_SmallClosingParenthesis) Then
        i = Start
        GoTo 100
    End If
    i = i + 1
100:
    GetParenthesisNumber = I16ArrayToStr(UText, Start, i - Start)
    Exit Function
1000:
    GetParenthesisNumber = ""
End Function

Private Function GetPwithN(UText() As Integer, ByVal Start As Long, ByRef NumberLen As Long, ByRef HasP As Boolean) As String
    HasP = False
    Dim i As Long: i = Start
    Dim s As String
    s = GetIntegerString(UText, i)
    i = i + Len(s)
    NumberLen = Len(s)
    s = GetParenthesisNumber(UText, i)
    HasP = s <> ""
    i = i + Len(s)
100:
    GetPwithN = I16ArrayToStr(UText, Start, i - Start)
End Function
