Attribute VB_Name = "Lib"
' Copyright 2003-2004 by Kazuya Ujihara <ujihara.jp>.
'
' The contents of this file are subject to the Mozilla Public License Version 1.1
' (the "License"); you may not use this file except in compliance with the License.
' You may obtain a copy of the License at http://www.mozilla.org/MPL/
'
' Software distributed under the License is distributed on an "AS IS" basis,
' WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
' for the specific language governing rights and limitations under the License.
'
' The Original Code is 'ChemFormatter'.
'
' The Initial Developer of the Original Code is Kazuya Ujihara. Portions created by
' the Initial Developer are Copyright (C) 2003-2004 by Kazuya Ujihara.
' All Rights Reserved.
'
' Contributor(s): all the names of the contributors are added in the source code
' where applicable.

Option Explicit

#If WIN <> 0 Then

Dim fso As Object 'FileSystemObject

Public Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Sub FillMemory Lib "kernel32" Alias "RtlFillMemory" (Destination As Any, ByVal Length As Long, ByVal Fill As Byte)
Public Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (Destination As Any, ByVal Length As Long)

Public Const MAX_PATH = 260

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_DYN_DATA = &H80000006

Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long         ' Note that if you declare the lpData parameter as String, you must pass it By Value.
Public Declare Function SHGetSpecialFolderPath Lib "Shell32" Alias "SHGetSpecialFolderPathA" (ByVal hwnd As Long, ByVal pszPath As String, ByVal csidl As csidl, ByVal fCreate As Long) As Long

Public Const KEY_GetCommands_VALUE = &H1

Public Const REGSTR_PATH_EXPLORER = "Software\Microsoft\Windows\CurrentVersion\Explorer"

Public Enum csidl
    CSIDL_DESKTOP = &H0                            ' <desktop>
    CSIDL_INTERNET = &H1                           ' Internet Explorer (icon on desktop)
    CSIDL_PROGRAMS = &H2                           ' Start Menu\Programs
    CSIDL_CONTROLS = &H3                           ' My Computer\Control Panel
    CSIDL_PRINTERS = &H4                           ' My Computer\Printers
    CSIDL_PERSONAL = &H5                           ' My Documents
    CSIDL_FAVORITES = &H6                          ' <user name>\Favorites
    CSIDL_STARTUP = &H7                            ' Start Menu\Programs\Startup
    CSIDL_RECENT = &H8                             ' <user name>\Recent
    CSIDL_SENDTO = &H9                             ' <user name>\SendTo
    CSIDL_BITBUCKET = &HA                          ' <desktop>\Recycle Bin
    CSIDL_STARTMENU = &HB                          ' <user name>\Start Menu
    CSIDL_DESKTOPDIRECTORY = &H10                  ' <user name>\Desktop
    CSIDL_DRIVES = &H11                            ' My Computer
    CSIDL_NETWORK = &H12                           ' Network Neighborhood
    CSIDL_NETHOOD = &H13                           ' <user name>\nethood
    CSIDL_FONTS = &H14                             ' windows\fonts
    CSIDL_TEMPLATES = &H15
    CSIDL_COMMON_STARTMENU = &H16                  ' All Users\Start Menu
    CSIDL_COMMON_PROGRAMS = &H17                   ' All Users\Programs
    CSIDL_COMMON_STARTUP = &H18                    ' All Users\Startup
    CSIDL_COMMON_DESKTOPDIRECTORY = &H19           ' All Users\Desktop
    CSIDL_APPDATA = &H1A                           ' <user name>\Application Data
    CSIDL_PRINTHOOD = &H1B                         ' <user name>\PrintHood
    CSIDL_LOCAL_APPDATA = &H1C                     ' <user name>\Local Settings\Applicaiton Data (non roaming)
    CSIDL_ALTSTARTUP = &H1D                        ' non localized startup
    CSIDL_COMMON_ALTSTARTUP = &H1E                 ' non localized common startup
    CSIDL_COMMON_FAVORITES = &H1F
    CSIDL_INTERNET_CACHE = &H20
    CSIDL_COOKIES = &H21
    CSIDL_HISTORY = &H22
    CSIDL_COMMON_APPDATA = &H23                    ' All Users\Application Data
    CSIDL_WINDOWS = &H24                           ' GetWindowsDirectory()
    CSIDL_SYSTEM = &H25                            ' GetSystemDirectory()
    CSIDL_PROGRAM_FILES = &H26                     ' C:\Program Files
    CSIDL_MYPICTURES = &H27                        ' C:\Program Files\My Pictures
    CSIDL_PROFILE = &H28                           ' USERPROFILE
    CSIDL_SYSTEMX86 = &H29                         ' x86 system directory on RISC
    CSIDL_PROGRAM_FILESX86 = &H2A                  ' x86 C:\Program Files on RISC
    CSIDL_PROGRAM_FILES_COMMON = &H2B              ' C:\Program Files\Common
    CSIDL_PROGRAM_FILES_COMMONX86 = &H2C           ' x86 Program Files\Common on RISC
    CSIDL_COMMON_TEMPLATES = &H2D                  ' All Users\Templates
    CSIDL_COMMON_DOCUMENTS = &H2E                  ' All Users\Documents
    CSIDL_COMMON_ADMINTOOLS = &H2F                 ' All Users\Start Menu\Programs\Administrative Tools
    CSIDL_ADMINTOOLS = &H30                        ' <user name>\Start Menu\Programs\Administrative Tools
    CSIDL_CONNECTIONS = &H31                       ' Network and Dial-up Connections
    CSIDL_FLAG_CREATE = &H8000                     ' combine with CSIDL_ value to force folder creation in SHGetFolderPath()
    CSIDL_FLAG_DONT_VERIFY = &H4000                ' combine with CSIDL_ value to return an unverified folder path
    CSIDL_FLAG_MASK = &HFF00                       ' mask for all possible flag values
End Enum

Dim VBScriptVersionChecked As Boolean

#End If

Public Const Unicode_Space = &H20 '
Public Const Unicode_Sharp = &H23 '#
Public Const Unicode_Apostrophe = &H27
Public Const Unicode_SmallOpeningParenthesis = &H28  '(
Public Const Unicode_SmallClosingParenthesis = &H29 ')
Public Const Unicode_Plus = &H2B    '+
Public Const Unicode_Comma = &H2C    ',
Public Const Unicode_Minus = &H2D    '-
Public Const Unicode_Period = &H2E    '.
Public Const Unicode_0 = &H30
Public Const Unicode_2 = &H32
Public Const Unicode_7 = &H37
Public Const Unicode_9 = &H39
Public Const Unicode_BigA = &H41
Public Const Unicode_BigZ = &H5A
Public Const Unicode_BigClosingParenthesis = &H5D   ']
Public Const Unicode_SmallA = &H61
Public Const Unicode_SmallZ = &H7A
Public Const Unicode_MiddleClosingParenthesis = &H7D    '}

Function UnicodeIsDigit(ByVal x As Integer) As Boolean
    UnicodeIsDigit = False
    If x < Unicode_0 Then Exit Function
    If x > Unicode_9 Then Exit Function
    UnicodeIsDigit = True
End Function

Function UnicodeIsAscii(ByVal x As Integer) As Boolean
    UnicodeIsAscii = False
    If Unicode_BigA <= x And x <= Unicode_BigZ Then
        UnicodeIsAscii = True
    ElseIf Unicode_SmallA <= x And x <= Unicode_SmallZ Then
        UnicodeIsAscii = True
    End If
End Function

Function UnicodeIsAlNum(ByVal x As Integer) As Boolean
    UnicodeIsAlNum = False
    If UnicodeIsDigit(x) Then
        UnicodeIsAlNum = True
    ElseIf UnicodeIsAscii(x) Then
        UnicodeIsAlNum = True
    End If
End Function

Function UnicodeIsSpace(ByVal x As Integer) As Boolean
    Select Case x
    Case 0 To &H20, &H3000
        UnicodeIsSpace = True
    Case Else
        UnicodeIsSpace = False
    End Select
End Function

Sub StrToI16Array(ByVal s As String, a() As Integer)
    Dim l As Long
    l = Len(s)
    ReDim a(0 To l) As Integer
    If l > 0 Then
#If WIN <> 0 Then
        Dim ba() As Byte
        ba = s
        Call CopyMemory(a(0), ba(0), l * 2)
#Else
        Dim i As Long
        For i = 0 To l - 1
            a(i) = AscW(Mid(s, i + 1, 1))
        Next
#End If
    End If
    a(l) = 0
End Sub

Function I16ArrayToStr(a() As Integer, ByVal Index As Long, ByVal Length As Long) As String
    If Length <= 0 Then
        I16ArrayToStr = ""
        Exit Function
    End If
    Dim s As String
#If WIN <> 0 Then
    Dim bb() As Byte
    ReDim bb(0 To Length * 2 - 1) As Byte
    Call CopyMemory(bb(0), a(Index), Length * 2)
    s = bb
#Else
    s = ""
    Dim i As Long
    For i = 0 To Length - 1
        s = s & ChrW$(a(Index + i))
    Next
#End If
    I16ArrayToStr = s
End Function

Function NormalizeString(ByVal Source As String) As String
    Dim s As String
    s = ""
    Dim i As Long
    For i = 1 To Len(Source)
        Dim l As Long
        l = AscW(Mid(Source, i, 1))
        l = NormalizeUnicode(l)
        s = s & ChrW$(l)
    Next
    NormalizeString = s
End Function

Function NormalizeUnicode(ByVal Unicode As Long) As Long
    'It should be re-written for Mac version.
    Const StartBasicLatin = &H20
    Const StartZenkaku = &HFF00
    Const EndZenkaku = &HFF5F
    Const StartHanKana = &HFF61
    Const EndHanKana = &HFF9F
    Select Case Unicode
    Case &H2019 'Zenkaku "'"
        NormalizeUnicode = &H27  'AscW("'")
    Case &H3000 'ZenkakuSpace
        NormalizeUnicode = &H20
    Case &HFE50 To &HFE52, &HFE54 To &HFE66, &HFE68 To &HFE6B
        NormalizeUnicode = AscW(Mid$(",A.?;:?!?(){}[]#&*+-<>=?" & Chr$(&H5C) & "$%@", Unicode - &HFE50 + 1, 1))
    Case StartZenkaku To EndZenkaku
        NormalizeUnicode = Unicode - StartZenkaku + StartBasicLatin
    Case StartHanKana To EndHanKana
        NormalizeUnicode = &H3F ' "?"
    Case &HFFE0 'cent
        NormalizeUnicode = &HA2
    Case &HFFE1 'pond
        NormalizeUnicode = &HA3
    Case &HFFE2 'not
        NormalizeUnicode = &HAC
    Case &HFFE3 'overline
        NormalizeUnicode = &HAF
    Case &HFFE4 'HARETSUSEN
        NormalizeUnicode = &HA6
    Case &HFFE5 'Japanese Yen
        NormalizeUnicode = &HA5   'AscW("\")
    Case &HFFE8 'TATESEN
        NormalizeUnicode = &H7C
    Case &HFFE9 To &HFFEC 'ARROWS
        NormalizeUnicode = Unicode - &HFFE9 + &H2190
    Case Else
        NormalizeUnicode = Unicode
    End Select
End Function

#If WIN <> 0 Then
Function CreateRegExp() As Object
    If Not VBScriptVersionChecked Then
        If Not CheckVBScriptVersion Then
            Err.Raise 1, , "Version of VBScript.dll is too low. Please install Windows Script 5.5 or more."
        End If
        VBScriptVersionChecked = True
    End If
    
    Dim RegExp As Object
    Set RegExp = CreateObject("VBScript.RegExp")
    RegExp.Global = True
    Set CreateRegExp = RegExp
End Function

Private Function CheckVBScriptVersion() As Boolean
    On Error GoTo 1000
    Dim RegExp As Object
    Set RegExp = CreateObject("VBScript.RegExp")
    RegExp.MultiLine = True
    On Error GoTo 0
    CheckVBScriptVersion = True
    Exit Function
1000:
    CheckVBScriptVersion = False
End Function

Function GetSpecialFolderName(ByVal csidl As Long, Optional ByVal Create As Boolean = False) As String
Attribute GetSpecialFolderName.VB_Description = "Get special folder name using CSIDL\r\nin : ByVal CSIDL As Long\r\nin : Optional ByVal Create As Boolean = False : Create if the folder does not exist.\r\nout : return as string : given folder name"

    GetSpecialFolderName = Space$(MAX_PATH)
    Dim hr As Long
    On Error Resume Next
    hr = SHGetSpecialFolderPath(0, GetSpecialFolderName, csidl, Create)
    Dim ErrNumber As Long: ErrNumber = Err.Number
    On Error GoTo 0
    If ErrNumber <> 0 Then GoTo 1000
    If hr = 0 Then GoTo 1000
    GoTo 1010
1000:
    Dim SubKey As String
    SubKey = REGSTR_PATH_EXPLORER & "\Shell Folders"
    Dim ValueName As String
    Select Case csidl
    Case CSIDL_APPDATA
        ValueName = "AppData"
    Case CSIDL_INTERNET_CACHE
        ValueName = "Cache"
    Case CSIDL_COOKIES
        ValueName = "Cookies"
    Case CSIDL_DESKTOPDIRECTORY
        ValueName = "Desktop"
    Case CSIDL_FAVORITES
        ValueName = "Favorites"
    Case CSIDL_FONTS
        ValueName = "Fonts"
    Case CSIDL_HISTORY
        ValueName = "History"
    Case CSIDL_LOCAL_APPDATA
        ValueName = "Local AppData"
    'Case
    '    ValueName = "Local Settings"
    Case CSIDL_MYPICTURES
        ValueName = "My Pictures"
    Case CSIDL_NETHOOD
        ValueName = "NetHood"
    Case CSIDL_PERSONAL
        ValueName = "Personal"
    Case CSIDL_PRINTHOOD
        ValueName = "PrintHood"
    Case CSIDL_PROGRAMS
        ValueName = "Programs"
    Case CSIDL_RECENT
        ValueName = "Recent"
    Case CSIDL_SENDTO
        ValueName = "SendTo"
    Case CSIDL_STARTMENU
        ValueName = "Start Menu"
    Case CSIDL_STARTUP
        ValueName = "Startup"
    Case CSIDL_TEMPLATES
        ValueName = "Templates"
    Case Else
        Select Case csidl
        Case CSIDL_COMMON_APPDATA
            If fso Is Nothing Then Set fso = CreateObject("Scripting.FileSystemObject")
            GetSpecialFolderName = fso.GetSpecialFolder(0).Path 'WindowsFolder = 0
        Case Else
            GoTo FatalError
        End Select
        Exit Function
    End Select
    Dim handle As Long
    hr = RegOpenKeyEx(HKEY_CURRENT_USER, SubKey, 0, KEY_GetCommands_VALUE, handle)
    If hr <> 0 Then GoTo FatalError
    hr = RegQueryValueEx(handle, ValueName, 0, 0, ByVal GetSpecialFolderName, Len(GetSpecialFolderName))
    If hr <> 0 Then GoTo FatalError
    hr = RegCloseKey(handle)
1010:
    GetSpecialFolderName = CutAfterNull(GetSpecialFolderName)
    Exit Function
FatalError:
    Err.Raise 5, , "Fatal on GetSpecialFolderName."
End Function

Function CutAfterNull(ByVal RowString As String) As String
    Dim NullPtr As Long
    NullPtr = InStr(RowString, vbNullChar)
    If NullPtr = 0 Then
        CutAfterNull = RowString
    Else
        CutAfterNull = Left$(RowString, NullPtr - 1)
    End If
End Function

#End If

Function ReplaceString(ByVal Source As String, ByVal Find As String, ByVal Replaced As String) As String
#If OLDVB <> 0 Then
    Dim p As Long
    p = 1
    Do
        p = InStr(p, Source, Find, vbTextCompare)
        If p = 0 Then Exit Do
        Source = Left$(Source, p - 1) & Replaced & Mid$(Source, p + Len(Find))
        p = p + Len(Replaced)
    Loop
    ReplaceString = Source
#Else
    ReplaceString = Replace(Source, Find, Replaced, , , vbTextCompare)
#End If
End Function

Sub SplitWord(ByVal Words As String, ByVal Delimit As String, WordsSet() As String)
#If OLDVB Then
    Dim LenDelimit As Long
    LenDelimit = Len(Delimit)
    Words = Words & Delimit
    Dim n As Long: n = 0
    Dim i As Long
    For i = 1 To Len(Words)
        If Mid(Words, i, LenDelimit) = Delimit Then
            n = n + 1
        End If
    Next
    ReDim WordsSet(0 To n - 1) As String
    Dim s As Long: s = 1
    Dim p As Long: p = 0
    For i = 0 To n - 1
        Dim x As Long
        x = InStr(s, Words, Delimit, vbBinaryCompare)
        If x = 0 Then Exit For
        WordsSet(i) = Mid$(Words, s, x - s)
        s = x + LenDelimit
    Next
#Else
    WordsSet = Split(Words, Delimit)
    If UBound(WordsSet) < 0 Then ReDim WordsSet(0 To 0)
#End If
End Sub

Function IsCollection(ByVal o As Object) As Boolean
    On Error GoTo 1000
    Dim a As Object
    For Each a In o
    Next
    IsCollection = True
ErrBye:
    Exit Function
1000:
    IsCollection = False
    GoTo ErrBye
End Function

Function XTrim(ByVal Source As String) As String
    Dim a() As Integer
    Call StrToI16Array(Source, a)
    Dim w0 As Long, w1 As Long
    Dim p As Long
    For p = 0 To UBound(a)
        If Not UnicodeIsSpace(a(p)) Then
            w0 = p
            GoTo 200
        End If
    Next
    w0 = UBound(a) + 1
    w1 = UBound(a)
    GoTo 300
200:
    For p = UBound(a) To w0 + 1 Step -1
        If Not UnicodeIsSpace(a(p)) Then
            w1 = p
            GoTo 300
        End If
    Next
    w1 = w0
300:
    XTrim = I16ArrayToStr(a, w0, w1 - w0 + 1)
GoExit:
End Function

