VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NMRSpecFormQuery"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Copyright 2004 by Kazuya Ujihara <ujihara.jp>.
'
' The contents of this file are subject to the Mozilla Public License Version 1.1
' (the "License"); you may not use this file except in compliance with the License.
' You may obtain a copy of the License at http://www.mozilla.org/MPL/
'
' Software distributed under the License is distributed on an "AS IS" basis,
' WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
' for the specific language governing rights and limitations under the License.
'
' The Original Code is 'ChemFormatter'.
'
' The Initial Developer of the Original Code is Kazuya Ujihara. Portions created by
' the Initial Developer are Copyright (C) 2004 by Kazuya Ujihara.
' All Rights Reserved.
'
' Contributor(s): all the names of the contributors are added in the source code
' where applicable.

'2004-06-03 New release
'2004-06-17 fixed a bug when the tail char is not cvbCr.

Option Explicit

Dim PropOrders() As Long
Dim OrdersOfPros() As Long
Dim TablePropOrders() As Long
Dim TableOrdersOfPros() As Long

Public JValueStyle As Long

Public Property Let SpecFormat(ByVal fmt As String)
    Call SplitNMRSpecFormat(fmt, PropOrders, OrdersOfPros)
End Property
Public Property Get SpecFormat() As String
    SpecFormat = MargeNMRSpecFormat(PropOrders)
End Property

Public Property Let TableFormat(ByVal fmt As String)
    Call SplitNMRSpecFormat(fmt, TablePropOrders, TableOrdersOfPros)
End Property

Function GetCommands(ByVal Text As String) As String
    Dim i As Long, j As Long, k As Long
    Text = NormalizeString(Text) 'Doesn't need stopper
    
    'AddCr if the last line does not end by vbCr.
    Dim AddCr As Boolean
    AddCr = Right$(Text, 1) <> vbCr
    If AddCr Then
        Text = Text & vbCr
    End If
    
    GetCommands = ""

    Dim Lines() As String
    Call SplitWord(Text, vbCr, Lines)
    
    GetCommands = GetCommands & MakeCommand1("GoTo", "EndOfSelection")
    If AddCr Then GetCommands = GetCommands & MakeCommand("TypeParagraph")
    GetCommands = GetCommands & MakeCommand1("TypeText", "!! ") 'avoid to create a word, ! is to avoid Word to delete space.
    GetCommands = GetCommands & MakeCommand1("GoTo", "PrevChar")
    GetCommands = GetCommands & MakeCommand1("GoTo", "PrevChar")
    
    Dim LineHeadPos As Long
    LineHeadPos = 0
    For i = 0 To UBound(Lines)
        If XTrim(Lines(i)) = "" Then GoTo 300
        Dim Elem() As String
        Call SplitWord(Lines(i), vbTab, Elem)
        ReDim Preserve Elem(NMRSpecFormatter_NumberOfValues - 1) As String
        Dim XElem() As String
        ReDim XElem(NMRSpecFormatter_NumberOfValues - 1)
        Dim IQs(NMRSpecFormatter_NumberOfValues - 1) As String
        For j = 0 To NMRSpecFormatter_NumberOfValues - 1
            XElem(j) = XTrim(Elem(j))
            IQs(j) = ""
        Next
        
        Dim s As String
        
        s = XElem(TableOrdersOfPros(NMRSpecFormatterC_ChemicalShift))
        If s = "" Then Err.Raise 1, , "Chemical shift is missing."
        For j = 1 To Len(s)
            Select Case Mid$(s, j, 1)
            Case "0" To "9", "-", ".", " ", ChrW$(&H7E), ChrW$(&HFF5E)
                '
            Case Else
                Err.Raise 1, , "Chemical shift is missing."
            End Select
        Next
        IQs(NMRSpecFormatterC_ChemicalShift) = MakeCommand1("TypeText", s)
        
        s = XElem(TableOrdersOfPros(NMRSpecFormatterC_NumberAndAtom))
        If s <> "" Then IQs(NMRSpecFormatterC_NumberAndAtom) = MakeCommand1("TypeText", s)
        
        s = XElem(TableOrdersOfPros(NMRSpecFormatterC_Pattern))
        If s <> "" Then IQs(NMRSpecFormatterC_Pattern) = MakeCommand1("TypeText", s)
        
        s = XElem(TableOrdersOfPros(NMRSpecFormatterC_JValues))
        If s <> "" Then
            Dim js() As String
            Call SplitWord(XElem(TableOrdersOfPros(NMRSpecFormatterC_JValues)), ",", js)
            IQs(NMRSpecFormatterC_JValues) = MakeCommand2("TypeStyledText", "J", "Italic") & MakeCommand1("TypeText", " = ")
            For j = 0 To UBound(js)
                Dim jv As String
                jv = XTrim(js(j))
                IQs(NMRSpecFormatterC_JValues) = IQs(NMRSpecFormatterC_JValues) & MakeCommand1("TypeText", CStr(jv))
                If JValueStyle = JValueStyle_Hz_Hz Or (JValueStyle = JValueStyle_0_Hz And j = UBound(js)) Then
                    IQs(NMRSpecFormatterC_JValues) = IQs(NMRSpecFormatterC_JValues) & MakeCommand1("TypeText", " Hz")
                End If
                If j <> UBound(js) Then
                    IQs(NMRSpecFormatterC_JValues) = IQs(NMRSpecFormatterC_JValues) & MakeCommand1("TypeText", ", ")
                End If
            Next
        End If
        
        s = XElem(TableOrdersOfPros(NMRSpecFormatterC_Comments))
        If s <> "" Then
            Dim p As Long
            p = LineHeadPos
            For j = 0 To TableOrdersOfPros(NMRSpecFormatterC_Comments) - 1
                p = p + Len(Elem(j)) + 1  ' not XElem !
            Next
            IQs(NMRSpecFormatterC_Comments) = _
                MakeCommand2("Copy", CStr(p), CStr(Len(RTrim(Elem(TableOrdersOfPros(NMRSpecFormatterC_Comments)))))) & _
                MakeCommand("Paste") 'not XElem, not Trim, RTrim is for remove last spaces.
        End If
        
        GetCommands = GetCommands & IQs(NMRSpecFormatterC_ChemicalShift)
        
        Dim PropExist As Boolean: PropExist = False
        For j = 1 To NMRSpecFormatter_NumberOfValues - 1
            If IQs(j) <> "" Then
                PropExist = True
                Exit For
            End If
        Next
        
        If PropExist Then
            GetCommands = GetCommands & MakeCommand1("TypeText", " (")
        
            For j = 1 To NMRSpecFormatter_NumberOfValues - 1
                Dim PropID As Long
                PropID = PropOrders(j)
                If IQs(PropID) <> "" Then
                    GetCommands = GetCommands & IQs(PropID) & MakeCommand1("TypeText", ", ")
                End If
            Next
            GetCommands = GetCommands & MakeCommand("TypeBackspace") & MakeCommand("TypeBackspace")
            GetCommands = GetCommands & MakeCommand1("TypeText", ")")
        End If
        GetCommands = GetCommands & MakeCommand1("TypeText", ", ")
300:
        LineHeadPos = LineHeadPos + Len(Lines(i)) + 1
    Next
    
    GetCommands = GetCommands & MakeCommand("TypeBackspace")
    GetCommands = GetCommands & MakeCommand("TypeBackspace")
    GetCommands = GetCommands & MakeCommand1("TypeText", ".")
    GetCommands = GetCommands & MakeCommand1("GoTo", "NextChar")
    GetCommands = GetCommands & MakeCommand("TypeBackspace")
    
    GetCommands = GetCommands & MakePushCommand(CStr(-1))
    GetCommands = GetCommands & MakePushCommand("$CursorPosition")
    GetCommands = GetCommands & MakePushCommand(CStr(Len(Text)))
    GetCommands = GetCommands & MakeCommand("Minus")
    GetCommands = GetCommands & MakeCommand2("Cut", CStr(0), Len(Text) + 1)
    GetCommands = GetCommands & MakeCommand("TypeBackspace")
    GetCommands = GetCommands & MakeCommand("Select")
End Function

Private Sub Class_Initialize()
    Me.SpecFormat = ""
    Me.TableFormat = ""
    JValueStyle = JValueStyle_Hz_Hz
End Sub


